# std::messages< CharT > Class Template Reference

Facet for handling message catalogs. More...

`#include <locale_facets.h>`

Inheritance diagram for std::messages< CharT >:

[legend]
Collaboration diagram for std::messages< CharT >:

[legend]
List of all members.

## Public Types

typedef CharT | char_type
| Public typedefs.
typedef basic_string< CharT > | string_type
| Public typedefs.

## Public Member Functions

| messages (size_t __refs=0)
| Constructor performs initialization.
| messages (c_locale cloc, const char *s, size_t __refs=0)
| Internal constructor. Not for general use.

## Static Public Attributes

locale::id | id
| Numpunct facet id.

## Protected Member Functions

virtual | ~messages ()
| Destructor.

## Detailed Description

### template<typename CharT>
class std::messages< CharT >

Facet for handling message catalogs.

This facet encapsulates the code to retrieve messages from message catalogs. The only thing defined by the standard for this facet is the interface. All underlying functionality is implementation-defined.

This library currently implements 3 versions of the message facet. The first version (gnu) is a wrapper around gettext, provided by libintl. The second version (ieee) is a wrapper around catgets. The final version (default) does no actual translation. These implementations are only provided for char and wchar_t instantiations.

The messages template uses protected virtual functions to provide the actual results. The public accessors forward the call to the virtual functions. These virtual functions are hooks for developers to implement the behavior they require from the messages facet.

Definition at line 4255 of file locale_facets.h.

## Member Typedef Documentation

template<typename CharT>
typedef CharT std::messages< CharT >::char_type

| Public typedefs. Definition at line 4261 of file locale_facets.h.

template<typename CharT>
typedef basic_string<CharT> std::messages< CharT >::string_type

| Public typedefs. Definition at line 4262 of file locale_facets.h.

## Constructor & Destructor Documentation

template<typename CharT>
std::messages< CharT >::messages | ( | size_t | __refs = `0` | ) | `[explicit]`

Constructor performs initialization.

This is the constructor provided by the standard.

Parameters:

  | refs | Passed to the base facet class.

template<typename CharT>
std::messages< CharT >::messages | ( | c_locale | cloc,
|  | const char * | s,
|  | size_t | __refs = `0`
| ) | `[explicit]`

Internal constructor. Not for general use.

This is a constructor for use by the library itself to set up new locales.

Parameters:

  | cloc | The "C" locale.
  | s | The name of a locale.
  | refs | Refcount to pass to the base class.

template<typename CharT>
virtual std::messages< CharT >::~messages | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Data Documentation

template<typename CharT>
locale::id std::messages< CharT >::id `[static]`

| Numpunct facet id. Definition at line 4457 of file locale_facets.h.

The documentation for this class was generated from the following file:

- locale_facets.h